package com.jasamedika.medifirst2000.vo;

import java.io.Serializable;
import javax.persistence.*;
import java.util.Date;
import org.hibernate.validator.constraints.NotEmpty;

import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import javax.validation.constraints.NotNull;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.internal.util.logging.Messages;

import com.fasterxml.jackson.annotation.JsonManagedReference;
import com.jasamedika.medifirst2000.base.vo.BaseMasterVO;
import com.jasamedika.medifirst2000.helper.Caption;

/**
 *  class HargaPaketPenjaminLuarPaket
 * 
 * @author Generator
 */
//@Entity
//@Table(name = "HargaPaketPenjaminLuarPaket_M")
public class HargaPaketPenjaminLuarPaketVO extends BaseMasterVO {
	@Caption(value="Factor Rate")
	private Double factorRate;

	public void setFactorRate(Double factorRate) {
		this.factorRate = factorRate;
	}

	@Column(name = "FactorRate", nullable = false )
	public Double getFactorRate(){
		return this.factorRate;
	}

	@Caption(value="Harga Satuan")
	private Double hargaSatuan;

	public void setHargaSatuan(Double hargaSatuan) {
		this.hargaSatuan = hargaSatuan;
	}

	@Column(name = "HargaSatuan", nullable = true )
	public Double getHargaSatuan(){
		return this.hargaSatuan;
	}

	@Caption(value="Is PaketVO By Produk")
	private Byte isPaketByProduk;

	public void setIsPaketByProduk(Byte isPaketByProduk) {
		this.isPaketByProduk = isPaketByProduk;
	}

	@Column(name = "isPaketByProduk", nullable = false )
	public Byte getIsPaketByProduk(){
		return this.isPaketByProduk;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectGolonganAsuransiFk")
	@NotNull(message="Object Golongan Asuransi Harus Diisi")
	@Caption(value="Object Golongan Asuransi")
	private GolonganAsuransiVO kdGolonganAsuransi;

	public void setGolonganAsuransi(GolonganAsuransiVO kdGolonganAsuransi) {
		this.kdGolonganAsuransi = kdGolonganAsuransi;
	}

	@Column(name = "KdGolonganAsuransi", nullable = false )
	public GolonganAsuransiVO getGolonganAsuransi(){
		return this.kdGolonganAsuransi;
	}

	@Column(name = "ObjectGolonganAsuransiFk", insertable=false,updatable=false)
	private Integer golonganAsuransiId;

	@ManyToOne
	@JoinColumn(name = "ObjectHubunganPesertaFk")
	@NotNull(message="Object Hubungan Peserta Harus Diisi")
	@Caption(value="Object Hubungan Peserta")
	private HubunganPesertaAsuransiVO hubunganPeserta;

	public void setHubunganPeserta(HubunganPesertaAsuransiVO hubunganPeserta) {
		this.hubunganPeserta = hubunganPeserta;
	}

	@Column(name = "KdHubunganPeserta", nullable = false )
	public HubunganPesertaAsuransiVO getHubunganPeserta(){
		return this.hubunganPeserta;
	}

	@Column(name = "ObjectHubunganPesertaFk", insertable=false,updatable=false)
	private Integer hubunganPesertaId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelasFk")
	@NotNull(message="Object KelasVO Harus Diisi")
	@Caption(value="Object Kelas")
	private DetailKamarVO kelas;

	public void setKelas(DetailKamarVO kelas) {
		this.kelas = kelas;
	}

	@Column(name = "KdKelas", nullable = false , length = 2)
	public DetailKamarVO getKelas(){
		return this.kelas;
	}

	@Column(name = "ObjectKelasFk", insertable=false,updatable=false)
	private Integer kelasId;

	@ManyToOne
	@JoinColumn(name = "ObjectKelompokPasienFk")
	@NotNull(message="Object Kelompok PasienVO Harus Diisi")
	@Caption(value="Object Kelompok Pasien")
	private KelompokPasienVO kelompokPasien;

	public void setKelompokPasien(KelompokPasienVO kelompokPasien) {
		this.kelompokPasien = kelompokPasien;
	}

	@Column(name = "KdKelompokPasien", nullable = false )
	public KelompokPasienVO getKelompokPasien(){
		return this.kelompokPasien;
	}

	@Column(name = "ObjectKelompokPasienFk", insertable=false,updatable=false)
	private Integer kelompokPasienId;

	@ManyToOne
	@JoinColumn(name = "ObjectPaketFk")
	@NotNull(message="Object PaketVO Harus Diisi")
	@Caption(value="Object Paket")
	private PaketVO paket;

	public void setPaket(PaketVO paket) {
		this.paket = paket;
	}

	@Column(name = "KdPaket", nullable = false )
	public PaketVO getPaket(){
		return this.paket;
	}

	@Column(name = "ObjectPaketFk", insertable=false,updatable=false)
	private Integer paketId;

	@Caption(value="Kode Penjamin Pasien")
	private short kdPenjaminPasien;

	public void setKdPenjaminPasien(short kdPenjaminPasien) {
		this.kdPenjaminPasien = kdPenjaminPasien;
	}

	@Column(name = "KdPenjaminPasien", nullable = false )
	public short getKdPenjaminPasien(){
		return this.kdPenjaminPasien;
	}

	@ManyToOne
	@JoinColumn(name = "ObjectProdukFk")
	@NotNull(message="Object ProdukVO Harus Diisi")
	@Caption(value="Object Produk")
	private ProdukVO produk;

	public void setProduk(ProdukVO produk) {
		this.produk = produk;
	}

	@Column(name = "KdProduk", nullable = false , length = 6)
	public ProdukVO getProduk(){
		return this.produk;
	}

	@Column(name = "ObjectProdukFk", insertable=false,updatable=false)
	private Integer produkId;

	@Caption(value="Max T Penjamin")
	private Double maxTPenjamin;

	public void setMaxTPenjamin(Double maxTPenjamin) {
		this.maxTPenjamin = maxTPenjamin;
	}

	@Column(name = "MaxTPenjamin", nullable = true )
	public Double getMaxTPenjamin(){
		return this.maxTPenjamin;
	}

	@Caption(value="Persen Harga Satuan")
	private Double persenHargaSatuan;

	public void setPersenHargaSatuan(Double persenHargaSatuan) {
		this.persenHargaSatuan = persenHargaSatuan;
	}

	@Column(name = "PersenHargaSatuan", nullable = true )
	public Double getPersenHargaSatuan(){
		return this.persenHargaSatuan;
	}

	@Caption(value="Persen T Penjamindr Selisih")
	private Double persenTPenjamindrSelisih;

	public void setPersenTPenjamindrSelisih(Double persenTPenjamindrSelisih) {
		this.persenTPenjamindrSelisih = persenTPenjamindrSelisih;
	}

	@Column(name = "PersenTPenjamindrSelisih", nullable = false )
	public Double getPersenTPenjamindrSelisih(){
		return this.persenTPenjamindrSelisih;
	}

	@Caption(value="Persen T Profiledr Selisih")
	private Double persenTProfiledrSelisih;

	public void setPersenTProfiledrSelisih(Double persenTProfiledrSelisih) {
		this.persenTProfiledrSelisih = persenTProfiledrSelisih;
	}

	@Column(name = "PersenTProfiledrSelisih", nullable = false )
	public Double getPersenTProfiledrSelisih(){
		return this.persenTProfiledrSelisih;
	}

	@Caption(value="Qty Max Produk")
	private short qtyMaxProduk;

	public void setqtyMaxProduk(short qtyMaxProduk) {
		this.qtyMaxProduk = qtyMaxProduk;
	}

	@Column(name = "QtyMaxProduk", nullable = true )
	public short getqtyMaxProduk(){
		return this.qtyMaxProduk;
	}

	@Caption(value="Tanggal Berlaku Akhir")
	private Date tglBerlakuAkhir;

	public void setTglBerlakuAkhir(Date tglBerlakuAkhir) {
		this.tglBerlakuAkhir = tglBerlakuAkhir;
	}

	@Column(name = "TglBerlakuAkhir", nullable = true )
	public Date getTglBerlakuAkhir(){
		return this.tglBerlakuAkhir;
	}

	@Caption(value="Tanggal Berlaku Awal")
	private Date tglBerlakuAwal;

	public void setTglBerlakuAwal(Date tglBerlakuAwal) {
		this.tglBerlakuAwal = tglBerlakuAwal;
	}

	@Column(name = "TglBerlakuAwal", nullable = false )
	public Date getTglBerlakuAwal(){
		return this.tglBerlakuAwal;
	}


}

